    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from the abstract
    62   * <A HREF="org.apache.bcel.classfile.Constant.html">Constant</A> class
    63   * and represents a reference to the name and signature
    64   * of a field or method.
    65   *
    66   * @version $Id: ConstantNameAndType.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    67   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    68   * @see     Constant
    69   */
    70  public final class ConstantNameAndType extends Constant {
    71    private int name_index;      // Name of field/method
    72    private int signature_index; // and its signature.
    73
    74    /***
    75     * Initialize from another object.
    76     */
    77    public ConstantNameAndType(ConstantNameAndType c) {
    78      this(c.getNameIndex(), c.getSignatureIndex());
    79    }
    80
    81    /***
    82     * Initialize instance from file data.
    83     *
    84     * @param file Input stream
    85     * @throws IOException
    86     */
    87    ConstantNameAndType(DataInputStream file) throws IOException
    88    {
    89      this((int)file.readUnsignedShort(), (int)file.readUnsignedShort());
    90    }
    91
    92    /***
    93     * @param name_index Name of field/method
    94     * @param signature_index and its signature
    95     */
    96    public ConstantNameAndType(int name_index,
    97  			     int signature_index)
    98    {
    99      super(Constants.CONSTANT_NameAndType);
    100     this.name_index      = name_index;
    101     this.signature_index = signature_index;
    102   }
    103
    104   /***
    105    * Called by objects that are traversing the nodes of the tree implicitely
    106    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    107    * fields, attributes, etc. spawns a tree of objects.
    108    *
    109    * @param v Visitor object
    110    */
    111   public void accept(Visitor v) {
    112     v.visitConstantNameAndType(this);
    113   }
    114
    115   /***
    116    * Dump name and signature index to file stream in binary format.
    117    *
    118    * @param file Output file stream
    119    * @throws IOException
    120    */
    121   public final void dump(DataOutputStream file) throws IOException
    122   {
    123     file.writeByte(tag);
    124     file.writeShort(name_index);
    125     file.writeShort(signature_index);
    126   }
    127
    128   /***
    129    * @return Name index in constant pool of field/method name.
    130    */
    131   public final int getNameIndex()      { return name_index; }
    132
    133   /*** @return name
    134    */
    135   public final String getName(ConstantPool cp) {
    136     return cp.constantToString(getNameIndex(), Constants.CONSTANT_Utf8);
    137   }
    138
    139   /***
    140    * @return Index in constant pool of field/method signature.
    141    */
    142   public final int getSignatureIndex() { return signature_index; }
    143
    144   /*** @return signature
    145    */
    146   public final String getSignature(ConstantPool cp) {
    147     return cp.constantToString(getSignatureIndex(), Constants.CONSTANT_Utf8);
    148   }
    149
    150   /***
    151    * @param name_index.
    152    */
    153   public final void setNameIndex(int name_index) {
    154     this.name_index = name_index;
    155   }
    156
    157   /***
    158    * @param signature_index.
    159    */
    160   public final void setSignatureIndex(int signature_index) {
    161     this.signature_index = signature_index;
    162   }
    163
    164   /***
    165    * @return String representation
    166    */
    167   public final String toString() {
    168     return super.toString() + "(name_index = " + name_index +
    169       ", signature_index = " + signature_index + ")";
    170   }
    171 }

This page was automatically generated by Maven